//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Collections;
using Produmex.Foundation.Data.DbClient;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.Providers;

namespace ASRSHandlerSanderVunderink
{
	class Program
	{
		private static string CONNECTION_STRING = "Server=NDB@SOL-HANA-03:30013;ServerType=HANA;CompanyDB=TFS68933_SSRA;UseTrusted=False;DbUserName=SYSTEM;DbPassword=SBO10BeasWMSB1UP;UserName=ssra;Password=1234;Pooling=True;MinPoolSize=2;MaxPoolSize=10;DBCultureInfo=en-US;LicenseServer=SOL-HANA-03:40000";

		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

		static void Main(string[] args)
		{
			try
			{
				Console.WriteLine(s_log.ToString());
				Console.WriteLine(CONNECTION_STRING);
				Execute();
			}
			catch (Exception ex)
			{
				s_log.Error("", ex);
				Console.WriteLine(ex);
				Console.ReadLine();
			}
		}
		static void Execute()
		{
			Console.WriteLine("Exporting picklists");
			ExportPicklists();
			Console.WriteLine("Importing files");
			Import();
		}
		private static void ExportPicklists()
		{
			try
			{
				s_log.Info("Start Kardex picking request - exporting picklists");
				//using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
				//{
				using (PmxDbConnectionDirect dbConn = PmxDbConnectionMgr.GetDirectConnection(SboConnectionString.ParseStringToObject(CONNECTION_STRING)))
				{
					dbConn.Open();
					string viewName = "PMX_PICKLIST_EXPORT";

					DbQueryBuilder qb = dbConn.DbTool.GetQueryBuilder();
					qb
					.Select.EscColumnName(PmxPickListTable.Columns.DocEntry.NAME)
					.Comma.EscColumnName(PmxPickListLineTable.Columns.StorLocCode.NAME).CRLF
					.From.EscTableName(viewName)
					.OrderBy.EscColumnName(PmxPickListTable.Columns.DocEntry.NAME);

					PmxDictionary<string, List<int>> picklistDocEntriesbyWA = new PmxDictionary<string, List<int>>();

					using (ISboRecordset rs = SboRecordsetHelper.RunQuery(s_log, qb, dbConn))
					{
						while (!rs.EoF)
						{
							int docEntry = rs.GetTypedValue<int>(PmxPickListTable.Columns.DocEntry.NAME);
							string wacode = rs.GetTypedValue<string>(PmxPickListLineTable.Columns.StorLocCode.NAME);
							if (!picklistDocEntriesbyWA.ContainsKey(wacode))
							{
								picklistDocEntriesbyWA.Add(wacode, new List<int>());
							}
							picklistDocEntriesbyWA[wacode].Add(docEntry);

							rs.MoveNext();
						}
					}
					PmxOseWarehouseAutomationProvider waProv = new PmxOseWarehouseAutomationProvider(dbConn);

					foreach (KeyValuePair<string, List<int>> picklistDocEntrybyWA in picklistDocEntriesbyWA)
					{
						s_log.Info($"Start Kardex picking request - exporting picklist for {picklistDocEntrybyWA.Key}");
						s_log.Info($"Connected picklists: {string.Join(", ", picklistDocEntrybyWA.Value)}");
						waProv.ExportPickListsForWarehouseAutomation(picklistDocEntrybyWA.Value, picklistDocEntrybyWA.Key, true);
						s_log.Info($"Stop Kardex picking request - exporting picklist for {picklistDocEntrybyWA.Key}");
					}

					s_log.Info("Stop Kardex picking request - exporting picklists");
				}

				//	scope.Complete();
				//}
			}
			catch (Exception ex)
			{
				s_log.Error("Stop Kardex picking request - exporting picklists with error: ", ex);
			}
		}
		private static void Import()
		{
			try
			{
				s_log.Info("Start Kardex import");
				//using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
				//{
				using (PmxDbConnectionDirect dbConn = PmxDbConnectionMgr.GetDirectConnection(SboConnectionString.ParseStringToObject(CONNECTION_STRING)))
				{
					dbConn.Open();
					
					PmxOseWarehouseAutomationProvider waProv = new PmxOseWarehouseAutomationProvider(dbConn);

					waProv.ImportWarehouseAutomationTextMessage(null);


					s_log.Info("Stop Kardex import - importing files");
				}

				//	scope.Complete();
				//}
			}
			catch (Exception ex)
			{
				s_log.Error("Stop Kardex picking request - exporting picklists with error: ", ex);
			}
		}
	}
}
